CREATE TABLE ieps (ieps_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, description TEXT, value REAL, is_percent  BOOLEAN);
INSERT INTO ieps VALUES(1, 'GASOLINA - DIESEL', 0.2988, 0);
INSERT INTO ieps VALUES(2, 'GASOLINA - MAGNA', 0.4392, 0);
INSERT INTO ieps VALUES(3, 'GASOLINA - PREMIUM', 0.36, 0);
CREATE TABLE factura_ieps (factura_ieps_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, ieps_id INTEGER, importe REAL, tasa REAL);
CREATE TABLE factura_iva (factura_iva_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, tasa REAL, importe REAL);
CREATE TEMPORARY TABLE productos_backup(producto_id, descripcion, descripcion_larga, unidad, categoria_id, precio, descripcion_AI, divisa_id, ieps_id, tasa_iva);
INSERT INTO productos_backup SELECT producto_id, descripcion, descripcion_larga, unidad, categoria_id, precio, descripcion_AI, divisa_id, NULL, NULL FROM productos;
DROP TABLE productos;
CREATE TABLE productos(producto_id INTEGER NOT NULL, descripcion TEXT NOT NULL,descripcion_larga TEXT NOT NULL, unidad TEXT NOT NULL, categoria_id INTEGER NOT NULL, precio REAL NOT NULL, descripcion_AI text NOT NULL DEFAULT 'nil' COLLATE NOCASE, divisa_id integer NOT NULL, ieps_id INTEGER, tasa_iva REAL, PRIMARY KEY (producto_id));
INSERT INTO productos SELECT producto_id, descripcion, descripcion_larga, unidad, categoria_id, precio, descripcion_AI, divisa_id, ieps_id, tasa_iva FROM productos_backup;
DROP TABLE productos_backup;
CREATE TEMP TABLE factura_productos_backup (factura_id, descripcion, descripcion_larga, unidad, precio,cantidad,producto_id,importe,divisa_name,divisa_value_mxn,cuenta_predial,factura_ieps_id,factura_iva_id, iva_tasa, iva_importe, descuento);
CREATE TEMP TRIGGER factura_productos_backup_add_iva AFTER INSERT ON factura_productos_backup FOR EACH ROW BEGIN INSERT INTO factura_iva values(NULL, NEW.iva_tasa, NEW.iva_importe);UPDATE factura_productos_backup SET factura_iva_id=last_insert_rowid() WHERE factura_productos_backup.factura_id = NEW.factura_id AND NEW.producto_id = factura_productos_backup.producto_id;  END;
INSERT INTO factura_productos_backup SELECT factura_id, descripcion, descripcion_larga, unidad, precio,cantidad,producto_id,importe,divisa_name,divisa_value_mxn,cuenta_predial,NULL,NULL,(SELECT IVA_porcentaje FROM facturas WHERE factura_id = factura_productos.factura_id),(SELECT IVA_porcentaje/100*factura_productos.importe FROM facturas WHERE factura_id = factura_productos.factura_id),0 FROM factura_productos;
DROP TABLE factura_productos;
CREATE TABLE factura_productos (factura_id INTEGER NOT NULL, descripcion TEXT NOT NULL, descripcion_larga TEXT NOT NULL, unidad TEXT NOT NULL, precio REAL NOT NULL, cantidad real NOT NULL, producto_id integer NOT NULL, importe REAL NOT NULL, divisa_name TEXT, divisa_value_mxn REAL, cuenta_predial TEXT, factura_ieps_id INTEGER, factura_iva_id INTEGER, descuento REAL, PRIMARY KEY (factura_id,producto_id));
INSERT INTO factura_productos SELECT factura_id, descripcion, descripcion_larga, unidad, precio,cantidad,producto_id,importe,divisa_name,divisa_value_mxn,cuenta_predial,factura_ieps_id,factura_iva_id, descuento FROM factura_productos_backup;
DROP TABLE factura_productos_backup;
CREATE TEMP TABLE facturas_backup(factura_id,uuid,descuento,ret_IVA,ret_ISR,subtotal,total,forma_pago,metodo_pago,tipo_cambio,serie_id,folio,tipo_documento,tipo_documento_desc,lugar_expedicion,etiqueta_id,ultima_modificacion_fecha,read,acuse_cancelacion_id,condiciones_pago,motivo_descuento,numero_cuenta_pago,folio_fiscal_original,serie_folio_fiscal_original,fecha_folio_fiscal_original,monto_folio_fiscal_original,observaciones, extras);
INSERT INTO facturas_backup SELECT factura_id,uuid,descuento,ret_IVA,ret_ISR,subtotal,total,forma_pago,metodo_pago,tipo_cambio,serie_id,folio,tipo_documento,tipo_documento_desc,lugar_expedicion,etiqueta_id,ultima_modificacion_fecha,read,acuse_cancelacion_id,condiciones_pago,motivo_descuento,numero_cuenta_pago,folio_fiscal_original,serie_folio_fiscal_original,fecha_folio_fiscal_original,monto_folio_fiscal_original,observaciones, NULL FROM facturas;
DROP TABLE facturas;
CREATE TABLE facturas(factura_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,uuid TEXT,descuento REAL NOT NULL,ret_IVA REAL NOT NULL,ret_ISR REAL NOT NULL,subtotal REAL NOT NULL,total REAL NOT NULL,forma_pago TEXT NOT NULL,metodo_pago TEXT NOT NULL,tipo_cambio REAL NOT NULL,serie_id INTEGER,folio INTEGER,tipo_documento TEXT NOT NULL,tipo_documento_desc TEXT NOT NULL,lugar_expedicion TEXT NOT NULL,etiqueta_id INTEGER,ultima_modificacion_fecha TEXT,read BOOLEAN,acuse_cancelacion_id INTEGER,condiciones_pago TEXT,motivo_descuento TEXT,numero_cuenta_pago TEXT,folio_fiscal_original TEXT,serie_folio_fiscal_original TEXT,fecha_folio_fiscal_original TEXT,monto_folio_fiscal_original REAL,observaciones TEXT, extras TEXT);
INSERT INTO facturas SELECT factura_id,uuid,descuento,ret_IVA,ret_ISR,subtotal,total,forma_pago,metodo_pago,tipo_cambio,serie_id,folio,tipo_documento,tipo_documento_desc,lugar_expedicion,etiqueta_id,ultima_modificacion_fecha,read,acuse_cancelacion_id,condiciones_pago,motivo_descuento,numero_cuenta_pago,folio_fiscal_original,serie_folio_fiscal_original,fecha_folio_fiscal_original,monto_folio_fiscal_original,observaciones, extras FROM facturas_backup;
DROP TABLE facturas_backup;
CREATE TRIGGER factura_productos_ieps_after_delete AFTER DELETE ON factura_productos FOR EACH ROW BEGIN DELETE FROM factura_ieps WHERE factura_ieps.factura_ieps_id = OLD.factura_ieps_id; END;
CREATE TRIGGER factura_productos_iva_after_delete AFTER DELETE ON factura_productos FOR EACH ROW BEGIN DELETE FROM factura_iva WHERE factura_iva.factura_iva_id = OLD.factura_iva_id; END;